Index: /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_qck.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 790)
+++ /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 791)
@@ -5,5 +5,5 @@
    !!======================================================================
    !! History :  1.0  !  06-09  (G. Reffray)  Original code
-   !!            2.4  !  08-01  (G. Madec)  Merge TRA-TRC
+   !!            2.4  !  2008-01  (G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -30,8 +30,5 @@
    PUBLIC tra_adv_qck    ! routine called by traadv.F90
 
-   REAL(wp), DIMENSION(jpi,jpj)     ::   zbtr2
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   sl
-   REAL(wp) ::   cst1, cst2, dt, coef1                  ! temporary scalars
-   INTEGER  ::   ji, jj, jk                             ! dummy loop indices
 
    !! * Substitutions
@@ -40,5 +37,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 2.4 , LOCEAN-IPSL (2008) 
-   !! $Id:$ 
+   !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -94,5 +91,7 @@
       REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta             ! tracer trend 
       !!
-      REAL(wp) :: z2                                   ! temporary scalar 
+      INTEGER  ::   ji, jj, jk        ! dummy loop indices
+      REAL(wp) ::   zdt, z2, zcoef1   ! temporary scalars
+      REAL(wp) ::   zbtr              ! temporary scalars
       !!----------------------------------------------------------------------
 
@@ -101,12 +100,8 @@
          IF(lwp) WRITE(numout,*) 'tra_adv_qck : 3st order quickest advection scheme'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-
-         zbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
-         cst1 = 1./12.
-         cst2 = 2./3.
       ENDIF
 
-      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.
-      ELSE                                        ;    z2 = 2.
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.      ! euler     time-stepping
+      ELSE                                        ;    z2 = 2.      ! leap-frog time-stepping
       ENDIF
 
@@ -116,27 +111,27 @@
       !---------------------------------------------------------------
 
+!!gm : optimisation: sl compute twice (for t & s, and even more for trc)
+!!gm   note that sl is in permanent memory be used as workspace in the vertical part !
       sl(:,:,:) = 100.
 
-                                                      ! ===============
-      DO jk = 1, jpkm1                                ! Horizontal slab
-        !                                             ! ===============
-        dt  = z2 * rdttra(jk)
-        DO jj = 2, jpjm1
-          DO ji = 2, fs_jpim1   ! vector opt.
-            coef1 = 1.e-12
-            IF (pun(ji-1,jj  ,jk  ).LT.0.) coef1 = coef1 + ABS(pun(ji-1,jj  ,jk  ))*dt/e1t(ji,jj)
-            IF (pun(ji  ,jj  ,jk  ).GT.0.) coef1 = coef1 + ABS(pun(ji  ,jj  ,jk  ))*dt/e1t(ji,jj)
-            IF (pvn(ji  ,jj-1,jk  ).LT.0.) coef1 = coef1 + ABS(pvn(ji  ,jj-1,jk  ))*dt/e2t(ji,jj)
-            IF (pvn(ji  ,jj  ,jk  ).GT.0.) coef1 = coef1 + ABS(pvn(ji  ,jj  ,jk  ))*dt/e2t(ji,jj)
-            IF (pwn(ji  ,jj  ,jk+1).LT.0.) coef1 = coef1 + ABS(pwn(ji  ,jj  ,jk+1))*dt/(fse3t(ji,jj,jk))
-            IF (pwn(ji  ,jj  ,jk  ).GT.0.) coef1 = coef1 + ABS(pwn(ji  ,jj  ,jk  ))*dt/(fse3t(ji,jj,jk))
-            sl(ji,jj,jk) = 1./coef1
-            sl(ji,jj,jk) = MIN(100.,sl(ji,jj,jk))
-            sl(ji,jj,jk) = MAX(1.  ,sl(ji,jj,jk))
-          ENDDO
-        ENDDO
-      ENDDO
-      !--- Lateral boundary conditions on the limiter slope
-      CALL lbc_lnk(   sl(:,:,:), 'T', 1. )
+      DO jk = 1, jpkm1
+         zdt  = z2 * rdttra(jk)
+         DO jj = 2, jpjm1
+            DO ji = 2, fs_jpim1   ! vector opt.
+               zbtr = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) *fse3t(ji,jj,jk) )
+               zcoef1 = 1.e-12
+               IF( pun(ji-1,jj  ,jk  ) < 0.e0 )   zcoef1 = zcoef1 + ABS( pun(ji-1,jj  ,jk  ) ) * zdt * zbtr
+               IF( pun(ji  ,jj  ,jk  ) > 0.e0 )   zcoef1 = zcoef1 + ABS( pun(ji  ,jj  ,jk  ) ) * zdt * zbtr
+               IF( pvn(ji  ,jj-1,jk  ) < 0.e0 )   zcoef1 = zcoef1 + ABS( pvn(ji  ,jj-1,jk  ) ) * zdt * zbtr
+               IF( pvn(ji  ,jj  ,jk  ) > 0.e0 )   zcoef1 = zcoef1 + ABS( pvn(ji  ,jj  ,jk  ) ) * zdt * zbtr
+               IF( pwn(ji  ,jj  ,jk+1) < 0.e0 )   zcoef1 = zcoef1 + ABS( pwn(ji  ,jj  ,jk+1) ) * zdt * zbtr
+               IF( pwn(ji  ,jj  ,jk  ) > 0.e0 )   zcoef1 = zcoef1 + ABS( pwn(ji  ,jj  ,jk  ) ) * zdt * zbtr
+               sl(ji,jj,jk) = 1. / zcoef1
+               sl(ji,jj,jk) = MIN( 100., sl(ji,jj,jk) )
+               sl(ji,jj,jk) = MAX( 1.  , sl(ji,jj,jk) )
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk( sl(:,:,:), 'T', 1. )      ! Lateral boundary conditions on the limiter slope
 
 
@@ -146,4 +141,5 @@
       CALL tra_adv_qck_hor( kt, cdtype, ktra, pun, pvn, ptb, pta, z2 )
 
+      !                                       ! control print
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' qck - had: ', mask1=tmask, clinfo3=cdtype )
 
@@ -152,6 +148,7 @@
       !-------------------------------------------------------------------------
 
-      CALL tra_adv_qck_ver( pwn, ptn , pta, z2 )
-
+      CALL tra_adv_qck_ver( pwn, ptn , pta )
+
+      !                                       ! control print
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' qck - zad: ', mask1=tmask, clinfo3=cdtype )
       !
@@ -159,6 +156,9 @@
 
 
-   SUBROUTINE tra_adv_qck_hor ( kt, cdtype, ktra, pun, pvn, ptb, pta, z2 )
-      !!----------------------------------------------------------------------
+   SUBROUTINE tra_adv_qck_hor ( kt, cdtype, ktra, pun, pvn, ptb, pta, pz2 )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_adv_qck_hor  ***
+      !!
+      !! ** Purpose :   
       !!
       !!----------------------------------------------------------------------
@@ -166,13 +166,14 @@
       CHARACTER(len=3), INTENT(in   )                         ::   cdtype      ! =TRA or TRC (tracer indicator)
       INTEGER         , INTENT(in   )                         ::   ktra        ! tracer index
-      REAL(wp)        , INTENT(in   )                         ::   z2          ! ???
+      REAL(wp)        , INTENT(in   )                         ::   pz2         ! =1 or 2 (euler or leap-frog)
       REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pun, pvn    ! horizontal effective velocity
       REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   ptb         ! before tracer field
       REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta         ! tracer trend
-
-      REAL(wp) ::   za, zbtr, e1, e2, c, dir, fu, fc, fd   ! temporary scalars
-      REAL(wp) ::   coef2, coef3, fho, mask, dx
-      REAL(wp), DIMENSION(jpi,jpj) ::  zee
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmask, zlap, dwst, lim 
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zdt                                     ! temporary scalars
+      REAL(wp) ::   zbtr, zc, zdir, zfu, zfc, zfd           ! temporary scalars
+      REAL(wp) ::   zcoef1, zcoef2, zcoef3, zfho, zmsk, zdx
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmask, zlap, zdwst, zlim 
       !!----------------------------------------------------------------------
 
@@ -182,6 +183,6 @@
       zmask(:,:,:)= 0.e0                                                
       zlap (:,:,:)= 0.e0                                                  
-      dwst (:,:,:)= 0.e0                                                  
-      lim  (:,:,:)= 0.e0     
+      zdwst(:,:,:)= 0.e0                                                  
+      zlim (:,:,:)= 0.e0     
                                             
       !----------------------------------------------------------------------
@@ -189,20 +190,5 @@
       !----------------------------------------------------------------------
 
-                                                       ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-         ! Initialization of metric arrays (for z- or s-coordinates)
-         ! ---------------------------------------------------------
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-#if defined key_zco
-               ! z-coordinates, no vertical scale factors
-               zee(ji,jj) = e2u(ji,jj) / e1u(ji,jj) * umask(ji,jj,jk)
-#else
-               ! vertical scale factor are used
-               zee(ji,jj) = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj) * umask(ji,jj,jk)
-#endif
-            END DO
-         END DO
+      DO jk = 1, jpkm1
 
          ! Laplacian of tracers (at before time step)
@@ -211,15 +197,12 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               zmask(ji,jj,jk) = zee(ji,jj) * ( ptb(ji+1,jj  ,jk) - ptb(ji,jj,jk) )
-            END DO
-         END DO
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zee(ji,jj) = e1t(ji,jj) /  e2t(ji,jj)
-#else
-               zee(ji,jj) = e1t(ji,jj) / (e2t(ji,jj) * fse3t(ji,jj,jk))
-#endif
-               zlap(ji,jj,jk) = zee(ji,jj) * (  zmask(ji,jj,jk) - zmask(ji-1,jj,jk)  )
+               zmask(ji,jj,jk) = e2u(ji,jj) * fse3u(ji,jj,jk) * umask(ji,jj,jk)                    &
+                  &                         * ( ptb(ji+1,jj  ,jk) - ptb(ji,jj,jk) ) / e1u(ji,jj)
+            END DO
+         END DO
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zlap(ji,jj,jk) = e1t(ji,jj) * (  zmask(ji,jj,jk) - zmask(ji-1,jj,jk)  )   &
+                  &                        / ( e2t(ji,jj) * fse3t(ji,jj,jk) )
             END DO
          END DO
@@ -231,66 +214,57 @@
             DO ji = 2, fs_jpim1   ! vector opt.
                ! Upstream in the x-direction for the tracer
-               zmask(ji,jj,jk) =ptb(ji-1,jj,jk)+sl(ji,jj,jk)*(ptb(ji,jj,jk)-ptb(ji-1,jj,jk))
+               zmask(ji,jj,jk) = ptb(ji-1,jj,jk) + sl(ji,jj,jk) *( ptb(ji,jj,jk) - ptb(ji-1,jj,jk) )
                ! Downstream in the x-direction for the tracer
-               dwst (ji,jj,jk) =ptb(ji+1,jj,jk)+sl(ji,jj,jk)*(ptb(ji,jj,jk)-ptb(ji+1,jj,jk))
-            ENDDO
-         ENDDO
-      END DO
-      !--- Lateral boundary conditions on the laplacian (unchanged sgn)
-      CALL lbc_lnk(   zlap(:,:,:), 'T', 1. ) 
-      !--- Lateral boundary conditions for the lim function
-      CALL lbc_lnk(  zmask(:,:,:), 'T', 1. )   ;   CALL lbc_lnk(  dwst(:,:,:), 'T', 1. )
-                                                       ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-         ! --- lim at the U-points in function of the direction of the flow
-         ! ----------------------------------------------------------------
+               zdwst(ji,jj,jk) = ptb(ji+1,jj,jk) + sl(ji,jj,jk) * ( ptb(ji,jj,jk) - ptb(ji+1,jj,jk) )
+            END DO
+         END DO
+      END DO
+
+      !--- Lateral boundary conditions on the laplacian and lim functions (unchanged sgn)
+      CALL lbc_lnk( zlap (:,:,:), 'T', 1. ) 
+      CALL lbc_lnk( zmask(:,:,:), 'T', 1. )   ;   CALL lbc_lnk(  zdwst(:,:,:), 'T', 1. )
+            
+      ! --- lim at the U-points in function of the direction of the flow
+      ! ----------------------------------------------------------------
+      DO jk = 1, jpkm1
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               dir = 0.5 + sign(0.5,pun(ji,jj,jk))     ! if pun>0 : diru = 1 otherwise diru = 0
-               lim(ji,jj,jk)=dir*zmask(ji,jj,jk)+(1-dir)*dwst(ji+1,jj,jk)
+               zdir = 0.5 + SIGN( 0.5, pun(ji,jj,jk) )     ! if pun>0 : diru = 1 otherwise diru = 0
+               zlim(ji,jj,jk) = zdir * zmask(ji,jj,jk) + (1-zdir) * zdwst(ji+1,jj,jk)
                ! Mask at the T-points in the x-direction (mask=0 or mask=1)
-               zmask(ji,jj,jk)=tmask(ji-1,jj,jk)+tmask(ji,jj,jk)+tmask(ji+1,jj,jk)-2
-            END DO
-         END DO
-      END DO
-      !--- Lateral boundary conditions for the mask
-      CALL lbc_lnk(  zmask(:,:,:), 'T', 1. )  
+               zmask(ji,jj,jk) = tmask(ji-1,jj,jk) + tmask(ji,jj,jk) + tmask(ji+1,jj,jk) - 2
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk(  zmask(:,:,:), 'T', 1. )       !--- Lateral boundary conditions for the mask
+
 
       ! Horizontal advective fluxes
       ! ---------------------------
-                                                       ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-                                                       ! ===============
-         dt  = z2 * rdttra(jk)
+      DO jk = 1, jpkm1
+         zdt  = pz2 * rdttra(jk)
          !--- tracer flux at u and v-points
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt. 
-#if defined key_zco
-               e2 = e2u(ji,jj)
-#else
-               e2 = e2u(ji,jj) * fse3u(ji,jj,jk)
-#endif
-               dir = 0.5 + sign(0.5,pun(ji,jj,jk))                ! if pun>0 : diru = 1 otherwise diru = 0
-
-               dx = dir * e1t(ji,jj) + (1-dir)* e1t(ji+1,jj)
-               c  = ABS(pun(ji,jj,jk))*dt/dx                      ! (0<cx<1 : Courant number on x-direction)
-
-               fu  = lim(ji,jj,jk)                                ! FU + sl(FC-FU) in the x-direction for T
-               fc  = dir*ptb(ji  ,jj,jk)+(1-dir)*ptb(ji+1,jj,jk)  ! FC in the x-direction for T
-               fd  = dir*ptb(ji+1,jj,jk)+(1-dir)*ptb(ji  ,jj,jk)  ! FD in the x-direction for T
+               zdir = 0.5 + SIGN( 0.5, pun(ji,jj,jk) )                     ! if pun>0 : diru = 1 otherwise diru = 0
+               zdx  = ( zdir * e1t(ji,jj) + (1-zdir)* e1t(ji+1,jj) ) * e2u(ji,jj) * fse3u(ji,jj,jk)
+               zc   = ABS( pun(ji,jj,jk) ) * zdt / zdx                     ! (0<cx<1 : Courant number on x-direction)
+
+               zfu  = zlim(ji,jj,jk)                                       ! FU + sl(FC-FU) in the x-direction for T
+               zfc  = zdir * ptb(ji  ,jj,jk) + (1-zdir) * ptb(ji+1,jj,jk)  ! FC in the x-direction for T
+               zfd  = zdir * ptb(ji+1,jj,jk) + (1-zdir) * ptb(ji  ,jj,jk)  ! FD in the x-direction for T
 
                !--- QUICKEST scheme
                ! Temperature on the x-direction
-               coef1 = 0.5*(fc+fd)
-               coef2 = 0.5*c*(fd-fc)
-               coef3 = ((1.-(c*c))/6.)*(dir*zlap(ji,jj,jk) + (1-dir)*zlap(ji+1,jj,jk) )
-               fho = coef1-coef2-coef3
-               fho = bound(fu,fd,fc,fho)
+               zcoef1 = 0.5      * ( zfc + zfd )
+               zcoef2 = 0.5 * zc * ( zfd - zfc )
+               zcoef3 = ( (1.-(zc*zc)) / 6. ) * ( zdir * zlap(ji,jj,jk) + (1-zdir) * zlap(ji+1,jj,jk) )
+               zfho = zcoef1 - zcoef2 - zcoef3
+               zfho = bound( zfu, zfd, zfc, zfho )
                !--- If the second ustream point is a land point
                !--- the flux is computed by the 1st order UPWIND scheme
-               mask=dir*zmask(ji,jj,jk)+(1-dir)*zmask(ji+1,jj,jk)
-               fho = mask*fho + (1-mask)*fc
-               dwst(ji,jj,jk)=e2*pun(ji,jj,jk)*fho
+               zmsk = zdir * zmask(ji,jj,jk) + (1-zdir) * zmask(ji+1,jj,jk)
+               zfho = zmsk * zfho            + (1-zmsk) * zfc
+               zdwst(ji,jj,jk) = pun(ji,jj,jk) * zfho
             END DO
          END DO
@@ -300,20 +274,13 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                !--- horizontal advective trends
-#if defined key_zco
-               zbtr = zbtr2(ji,jj)
-#else
-               zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)              
-#endif
-               za = - zbtr * ( dwst(ji,jj,jk) - dwst(ji-1,jj  ,jk) )
+               zbtr = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                !--- add it to the general tracer trends
-               pta(ji,jj,jk) = pta(ji,jj,jk) + za
-            END DO
-         END DO
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
-
-      ! Save the horizontal advective trends for diagnostic
-      IF( l_trdtra )   CALL trd_tra_adv( kt, ktra, jpt_trd_xad, cdtype, dwst, pun, ptb )
+               pta(ji,jj,jk) = pta(ji,jj,jk) - zbtr * ( zdwst(ji,jj,jk) - zdwst(ji-1,jj  ,jk) )
+            END DO
+         END DO
+      END DO
+
+      !                                            !-- trend diagnostic
+      IF( l_trdtra )   CALL trd_tra_adv( kt, ktra, jpt_trd_xad, cdtype, zdwst, pun, ptb )
 
 
@@ -321,20 +288,6 @@
       ! I. Part 2 : y-direction
       !----------------------------------------------------------------------
-                                                       ! ==============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-         ! Initialization of metric arrays (for z- or s-coordinates)
-         ! ---------------------------------------------------------
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-#if defined key_zco
-               ! z-coordinates, no vertical scale factors
-               zee(ji,jj) = e1v(ji,jj) / e2v(ji,jj) * vmask(ji,jj,jk)
-#else
-               ! s-coordinates, vertical scale factor are used
-               zee(ji,jj) = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj) * vmask(ji,jj,jk)
-#endif
-            END DO
-         END DO
+
+      DO jk = 1, jpkm1
 
          ! Laplacian of tracers (at before time step)
@@ -343,5 +296,6 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               zmask(ji,jj,jk) = zee(ji,jj) * ( ptb(ji  ,jj+1,jk) - ptb(ji,jj,jk) )
+               zmask(ji,jj,jk) = e1v(ji,jj) * fse3v(ji,jj,jk)   &
+                  &            * ( ptb(ji  ,jj+1,jk) - ptb(ji,jj,jk) ) / e2v(ji,jj) * vmask(ji,jj,jk)
             END DO
          END DO
@@ -349,10 +303,6 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zee(ji,jj) = e2t(ji,jj) /  e1t(ji,jj)
-#else
-               zee(ji,jj) = e2t(ji,jj) / (e1t(ji,jj) * fse3t(ji,jj,jk))
-#endif
-               zlap(ji,jj,jk) = zee(ji,jj) * (  zmask(ji,jj,jk) - zmask(ji,jj-1,jk)  )
+               zlap(ji,jj,jk) = e2t(ji,jj) * (  zmask(ji,jj,jk) - zmask(ji,jj-1,jk)  )   &
+                  &                        / ( e1t(ji,jj) * fse3t(ji,jj,jk) )
             END DO
          END DO
@@ -362,66 +312,57 @@
             DO ji = 2, fs_jpim1   ! vector opt.
                ! Upstream in the y-direction for the tracer
-               zmask(ji,jj,jk)=ptb(ji,jj-1,jk)+sl(ji,jj,jk)*(ptb(ji,jj,jk)-ptb(ji,jj-1,jk))
+               zmask(ji,jj,jk) = ptb(ji,jj-1,jk) + sl(ji,jj,jk) *( ptb(ji,jj,jk) - ptb(ji,jj-1,jk) )
                ! Downstream in the y-direction for the tracer
-               dwst (ji,jj,jk)=ptb(ji,jj+1,jk)+sl(ji,jj,jk)*(ptb(ji,jj,jk)-ptb(ji,jj+1,jk))
+               zdwst(ji,jj,jk) = ptb(ji,jj+1,jk) + sl(ji,jj,jk) *( ptb(ji,jj,jk) - ptb(ji,jj+1,jk) )
             ENDDO
          ENDDO
       END DO
-      !--- Lateral boundary conditions on the laplacian (unchanged sgn)
-      CALL lbc_lnk(   zlap(:,:,:), 'T', 1. )
-      !--- Lateral boundary conditions for the lim function
-      CALL lbc_lnk(  zmask(:,:,:), 'T', 1. )   ;   CALL lbc_lnk(  dwst(:,:,:), 'T', 1. )
-
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
+      !--- Lateral boundary conditions on the laplacian and lim function (unchanged sgn)
+      CALL lbc_lnk( zlap (:,:,:), 'T', 1. )
+      CALL lbc_lnk( zmask(:,:,:), 'T', 1. )   ;   CALL lbc_lnk( zdwst(:,:,:), 'T', 1. )
+
+      DO jk = 1, jpkm1
+      
          ! --- lim at the V-points in function of the direction of the flow
          ! ----------------------------------------------------------------
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               dir = 0.5 + sign(0.5,pvn(ji,jj,jk))      ! if pvn>0 : dirv = 1 otherwise dirv = 0
-               lim(ji,jj,jk)=dir*zmask(ji,jj,jk)+(1-dir)*dwst(ji,jj+1,jk)
+               zdir = 0.5 + SIGN( 0.5, pvn(ji,jj,jk) )      ! if pvn>0 : dirv = 1 otherwise dirv = 0
+               zlim(ji,jj,jk) = zdir * zmask(ji,jj,jk) + (1-zdir) * zdwst(ji,jj+1,jk)
                ! Mask at the T-points in the y-direction (mask=0 or mask=1)
-               zmask(ji,jj,jk)=tmask(ji,jj-1,jk)+tmask(ji,jj,jk)+tmask(ji,jj+1,jk)-2
-            END DO
-         END DO
-      END DO
-      !--- Lateral boundary conditions for the mask
-      CALL lbc_lnk(  zmask(:,:,:), 'T', 1. ) 
+               zmask(ji,jj,jk) = tmask(ji,jj-1,jk) + tmask(ji,jj,jk) + tmask(ji,jj+1,jk) - 2.
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk(  zmask(:,:,:), 'T', 1. )      !--- Lateral boundary conditions for the mask
 
       ! Horizontal advective fluxes
-      ! -------------------------------
-                                                       ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-                                                       ! ===============
-         dt  = z2 * rdttra(jk)
+      ! ---------------------------
+                                  
+      DO jk = 1, jpkm1           
+         zdt  = pz2 * rdttra(jk)
          !--- tracer flux at u and v-points
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-#if defined key_zco
-               e1 = e1v(ji,jj)
-#else
-               e1 = e1v(ji,jj) * fse3v(ji,jj,jk)
-#endif
-               dir = 0.5 + sign(0.5,pvn(ji,jj,jk))                ! if pvn>0 : dirv = 1 otherwise dirv = 0
-
-               dx = dir * e2t(ji,jj) + (1-dir)* e2t(ji,jj+1)
-               c  = ABS(pvn(ji,jj,jk))*dt/dx                      ! (0<cy<1 : Courant number on y-direction)
-
-               fu  = lim(ji,jj,jk)                                ! FU + sl(FC-FU) in the y-direction for T
-               fc  = dir*ptb(ji,jj  ,jk)+(1-dir)*ptb(ji,jj+1,jk)  ! FC in the y-direction for T
-               fd  = dir*ptb(ji,jj+1,jk)+(1-dir)*ptb(ji,jj  ,jk)  ! FD in the y-direction for T
+               zdir = 0.5 + SIGN( 0.5, pvn(ji,jj,jk) )                     ! if pvn>0 : dirv = 1 otherwise dirv = 0
+               zdx  = ( zdir * e2t(ji,jj) + (1-zdir)* e2t(ji,jj+1) ) * e1v(ji,jj) * fse3v(ji,jj,jk)
+               zc   = ABS( pvn(ji,jj,jk) ) * zdt / zdx                     ! (0<cy<1 : Courant number on y-direction)
+
+               zfu  = zlim(ji,jj,jk)                                       ! FU + sl(FC-FU) in the y-direction for T
+               zfc  = zdir * ptb(ji,jj  ,jk) + (1-zdir) * ptb(ji,jj+1,jk)  ! FC in the y-direction for T
+               zfd  = zdir * ptb(ji,jj+1,jk) + (1-zdir) * ptb(ji,jj  ,jk)  ! FD in the y-direction for T
 
                !--- QUICKEST scheme
                ! Temperature on the y-direction
-               coef1 = 0.5*(fc+fd)
-               coef2 = 0.5*c*(fd-fc)
-               coef3 = ((1.-(c*c))/6.)*(dir*zlap(ji,jj,jk) + (1-dir)*zlap(ji,jj+1,jk) )
-               fho = coef1-coef2-coef3
-               fho = bound(fu,fd,fc,fho)
+               zcoef1 = 0.5      * ( zfc + zfd )
+               zcoef2 = 0.5 * zc * ( zfd - zfc )
+               zcoef3 = ( (1.-(zc*zc)) / 6. ) * ( zdir * zlap(ji,jj,jk) + (1-zdir) * zlap(ji,jj+1,jk) )
+               zfho = zcoef1 - zcoef2 - zcoef3
+               zfho = bound( zfu, zfd, zfc, zfho )
                !--- If the second ustream point is a land point
                !--- the flux is computed by the 1st order UPWIND scheme
-               mask=dir*zmask(ji,jj,jk)+(1-dir)*zmask(ji,jj+1,jk)
-               fho = mask*fho + (1-mask)*fc
-               dwst(ji,jj,jk)=e1*pvn(ji,jj,jk)*fho
+               zmsk = zdir * zmask(ji,jj,jk) + (1-zdir) * zmask(ji,jj+1,jk)
+               zfho = zmsk * zfho            + (1-zmsk) * zfc
+               zdwst(ji,jj,jk) = pvn(ji,jj,jk) * zfho
             END DO
          END DO
@@ -430,35 +371,17 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               !--- horizontal advective trends
-#if defined key_zco
-               zbtr = zbtr2(ji,jj)
-#else
-               zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
-#endif
-               za = - zbtr * (  dwst(ji,jj,jk) - dwst(ji  ,jj-1,jk) )
-               !--- add it to the general tracer trends
-               pta(ji,jj,jk) = pta(ji,jj,jk) + za
-            END DO
-         END DO
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
-
-      ! Save the horizontal advective trends for diagnostic
-      IF( l_trdtra )   CALL trd_tra_adv( kt, ktra, jpt_trd_yad, cdtype, dwst, pvn, ptb )
-
-      ! "zonal" mean advective heat and salt transport 
+               zbtr = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               ! horizontal advective trends added to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) - zbtr * (  zdwst(ji,jj,jk) - zdwst(ji,jj-1,jk) )
+            END DO
+         END DO
+      END DO 
+
+      !                                           !-- trend diagnostic
+      IF( l_trdtra )   CALL trd_tra_adv( kt, ktra, jpt_trd_yad, cdtype, zdwst, pvn, ptb )
+      !                                           ! "Poleward" heat or salt transport 
       IF( ln_diaptr .AND. cdtype == 'TRA' .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-#if defined key_zco
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  dwst(ji,jj,jk) = dwst(ji,jj,jk) * fse3v(ji,jj,jk)
-               END DO
-            END DO
-         END DO
-# endif
-         IF( ktra == jp_tem)   pht_adv(:) = ptr_vj( dwst(:,:,:) )
-         IF( ktra == jp_sal)   pst_adv(:) = ptr_vj( dwst(:,:,:) )
+         IF( ktra == jp_tem)   pht_adv(:) = ptr_vj( zdwst(:,:,:) )
+         IF( ktra == jp_sal)   pst_adv(:) = ptr_vj( zdwst(:,:,:) )
       ENDIF
       !
@@ -466,14 +389,18 @@
 
 
-   SUBROUTINE tra_adv_qck_ver( pwn, ptn , pta, z2  )      
-      !!----------------------------------------------------------------------
-      !!
-      !!----------------------------------------------------------------------
-      REAL(wp), INTENT(in   )                         ::   z2
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pwn
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   ptn
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta
-      !!
-      REAL(wp) ::   za, ze3tr, dt, dir, fc, fd             ! temporary scalars
+   SUBROUTINE tra_adv_qck_ver( pwn, ptn , pta )      
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_adv_qck_ver  ***
+      !!
+      !! ** Purpose :   
+      !!
+      !!----------------------------------------------------------------------
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pwn   ! vertical transport
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   ptn   ! now tracer
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta   ! tracer trend
+      !!
+      INTEGER  ::   ji, jj , jk                  ! dummy loop indices
+      REAL(wp) ::   zbtr, zdir, zfc, zfd   ! temporary scalars
+      !!----------------------------------------------------------------------
 
       ! Vertical advection
@@ -483,23 +410,23 @@
       ! ----------------------------
 
-      sl(:,:,jpk) = 0.e0      !Bottom value : flux set to zero
-
-      ! Surface value
-      IF( lk_dynspg_rl .OR. lk_vvl ) THEN         ! rigid lid : flux set to zero
-         sl(:,:, 1 ) = 0.e0
-      ELSE                                        ! free surface-constant volume
-         sl(:,:, 1 ) = pwn(:,:,1) * ptn(:,:,1)
+      sl(:,:,jpk) = 0.e0                          ! bottom value 
+
+      !                                           ! Surface value
+      IF( lk_dynspg_rl .OR. lk_vvl ) THEN   ;   sl(:,:, 1 ) = 0.e0                      ! rigid lid or non-linear fs
+      ELSE                                  ;   sl(:,:, 1 ) = pwn(:,:,1) * ptn(:,:,1)   ! linear free surface
       ENDIF
+
+!!gm  bug: code au true 2nd order scheme
+!!gm  : sl used as work array: not good idea for optimisation (sl compute once for all tracers...)
 
       ! Second order centered tracer flux at w-point
       DO jk = 2, jpkm1
-         dt  = z2 *  rdttra(jk)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               dir = 0.5 + sign(0.5,pwn(ji,jj,jk))                                         ! if pwn>0 : dirw = 1 otherwise dirw = 0
-               fc = dir*ptn(ji,jj,jk  )*fse3t(ji,jj,jk-1)+(1-dir)*ptn(ji,jj,jk-1)*fse3t(ji,jj,jk  )   ! FC in the z-direction for T
-               fd = dir*ptn(ji,jj,jk-1)*fse3t(ji,jj,jk  )+(1-dir)*ptn(ji,jj,jk  )*fse3t(ji,jj,jk-1)   ! FD in the z-direction for T
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zdir = 0.5 + SIGN( 0.5, pwn(ji,jj,jk) )                        ! if pwn>0 : dirw = 1 otherwise dirw = 0
+               zfc = zdir * ptn(ji,jj,jk  ) * fse3t(ji,jj,jk-1) + (1-zdir) * ptn(ji,jj,jk-1) * fse3t(ji,jj,jk  )   ! FC 
+               zfd = zdir * ptn(ji,jj,jk-1) * fse3t(ji,jj,jk  ) + (1-zdir) * ptn(ji,jj,jk  ) * fse3t(ji,jj,jk-1)   ! FD
                !--- Second order centered scheme
-               sl(ji,jj,jk)=pwn(ji,jj,jk)*(fc+fd)/(fse3t(ji,jj,jk-1)+fse3t(ji,jj,jk))
+               sl(ji,jj,jk) = pwn(ji,jj,jk) * ( zfc + zfd ) / ( fse3t(ji,jj,jk-1) + fse3t(ji,jj,jk) )
             END DO
          END DO
@@ -511,9 +438,7 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               ze3tr = 1. / fse3t(ji,jj,jk)
-               ! vertical advective trends
-               za = - ze3tr * ( sl(ji,jj,jk) - sl(ji,jj,jk+1) )
-               ! add it to the general tracer trends
-               pta(ji,jj,jk) =  pta(ji,jj,jk) + za
+               zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               ! vertical advective trends added to the general tracer trends
+               pta(ji,jj,jk) =  pta(ji,jj,jk) - zbtr * ( sl(ji,jj,jk) - sl(ji,jj,jk+1) )
             END DO
          END DO
